# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Defined types

* [`vcsdeploy`](#vcsdeploy): Deploy an application using VCS

## Defined types

### <a name="vcsdeploy"></a>`vcsdeploy`

This defined type will deploy an application that comes from a repository.

At first fetch and on updates, this will run a custom command.

#### Examples

##### 

```puppet
vcsdeploy { '/path/to/application':
  ensure              => latest,
  source              => 'https://gitlab.com/corporation/application',
  after_fetch_command => '/path/to/application/bin/deploy',
}
```

#### Parameters

The following parameters are available in the `vcsdeploy` defined type:

* [`source`](#source)
* [`after_fetch_command`](#after_fetch_command)
* [`ensure`](#ensure)
* [`target`](#target)
* [`revision`](#revision)
* [`user`](#user)
* [`group`](#group)
* [`vcsrepo_attributes`](#vcsrepo_attributes)
* [`after_fetch_command_attributes`](#after_fetch_command_attributes)
* [`after_fetch_resources`](#after_fetch_resources)

##### <a name="source"></a>`source`

Data type: `String[1]`

The source URI for the repository

##### <a name="after_fetch_command"></a>`after_fetch_command`

Data type: `Stdlib::Absolutepath`

The command to execute after VCS fetch

##### <a name="ensure"></a>`ensure`

Data type: `Enum[latest, present, absent]`

Ensure the version control repository

Default value: `latest`

##### <a name="target"></a>`target`

Data type: `Stdlib::Absolutepath`

The target path to fetch repository

Default value: `$name`

##### <a name="revision"></a>`revision`

Data type: `String[1]`

The revision of the repository

Default value: `'master'`

##### <a name="user"></a>`user`

Data type: `Optional[String[1]]`

The user/uid that owns the repository files and run after fetch command

Default value: ``undef``

##### <a name="group"></a>`group`

Data type: `Optional[String[1]]`

The group/gid that owns the repository files and run after fetch command

Default value: `$user`

##### <a name="vcsrepo_attributes"></a>`vcsrepo_attributes`

Data type: `Hash`

The additionnal attributes passed to `vcsrepo` resource

Default value: `{}`

##### <a name="after_fetch_command_attributes"></a>`after_fetch_command_attributes`

Data type: `Hash`

The additionnal attributes passed to `exec` resource

Default value: `{}`

##### <a name="after_fetch_resources"></a>`after_fetch_resources`

Data type: `Array[Type[Resource]]`

The resources that need to be realized after a fetch

Default value: `[]`

